#ifndef PREPROCANIMATIONHEADER
#define PREPROCANIMATIONHEADER
#include<allegro.h>
#ifdef WIN32
    #include<winalleg.h>
#endif
#include<list>
using namespace std;

class CAnimation
{
public:
    CAnimation();
    CAnimation(DATAFILE *, int);
    ~CAnimation();
    
    void addFrame(BITMAP *, int);
    BITMAP *getCurr();
    virtual void reset() {currFrame = frames.begin(); currTime = frameTimes.begin(); currFrameTimes = 0;};
    virtual void update(); //must be called regularly (like 60times a seccond, or 100times a seccond)
protected:
    list<BITMAP *> frames;
    list<int> frameTimes;
    list<BITMAP *>::iterator currFrame;
    list<int>::iterator currTime;
    int currFrameTimes;
};

class CAnimationR : public CAnimation
{
public:
    CAnimationR() : CAnimation() {};
    CAnimationR(DATAFILE *file, int totlen) : CAnimation(file, totlen) {};
    ~CAnimationR() { };
    
    void update();
    void reset() {currFrame = frames.end(); currTime = frameTimes.end(); currFrameTimes = 0; currFrame--; currTime--;};
};

#endif
